VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "RICHTX32.OCX"
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   7575
   ClientLeft      =   45
   ClientTop       =   375
   ClientWidth     =   10155
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   7575
   ScaleWidth      =   10155
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame fraImageInfo 
      Caption         =   "Image info"
      Height          =   1875
      Left            =   120
      TabIndex        =   12
      Top             =   5100
      Width           =   9855
      Begin VB.TextBox txtImageinfo 
         Appearance      =   0  '
         BackColor       =   &H8000000F&
         BorderStyle     =   0  '
         Height          =   1515
         Left            =   120
         Locked          =   -1  'True
         MultiLine       =   -1  'True
         TabIndex        =   13
         Top             =   300
         Width           =   9615
      End
   End
   Begin VB.Frame fraLog 
      Caption         =   "Log"
      Height          =   2175
      Left            =   120
      TabIndex        =   10
      Top             =   2880
      Width           =   9855
      Begin VB.Timer tmrLog 
         Interval        =   500
         Left            =   4440
         Top             =   300
      End
      Begin RichTextLib.RichTextBox txtLog 
         Height          =   1815
         Left            =   120
         TabIndex        =   11
         Top             =   240
         Width           =   9615
         _ExtentX        =   16960
         _ExtentY        =   3201
         _Version        =   393217
         BackColor       =   -2147483633
         BorderStyle     =   0
         ReadOnly        =   -1  'True
         ScrollBars      =   3
         Appearance      =   0
         RightMargin     =   30000
         TextRTF         =   $"frmMain.frx":0000
      End
   End
   Begin VB.CommandButton cmdApply 
      Caption         =   "Apply"
      Height          =   495
      Left            =   120
      TabIndex        =   9
      Top             =   2280
      Width           =   9855
   End
   Begin VB.CommandButton cmdApplyPath 
      Caption         =   "Browse..."
      Height          =   375
      Left            =   8580
      TabIndex        =   8
      Top             =   1800
      Width           =   1335
   End
   Begin VB.TextBox txtApplyPath 
      Height          =   375
      Left            =   120
      TabIndex        =   7
      Text            =   "r:\"
      Top             =   1800
      Width           =   8415
   End
   Begin VB.CommandButton cmdPickTemp 
      Caption         =   "Browse..."
      Height          =   375
      Left            =   8580
      TabIndex        =   5
      Top             =   1080
      Width           =   1335
   End
   Begin VB.TextBox txtTempPath 
      Height          =   375
      Left            =   120
      TabIndex        =   4
      Text            =   "r:\"
      Top             =   1080
      Width           =   8415
   End
   Begin VB.CommandButton cmdPickWIM 
      Caption         =   "Browse..."
      Height          =   375
      Left            =   8580
      TabIndex        =   2
      Top             =   360
      Width           =   1335
   End
   Begin VB.TextBox txtPath 
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Text            =   "r:\boot.wim"
      Top             =   360
      Width           =   8415
   End
   Begin VB.Label lblTestProgress 
      BackColor       =   &H00E0E0E0&
      Caption         =   "Label2"
      Height          =   255
      Left            =   240
      TabIndex        =   14
      Top             =   7080
      Width           =   9735
   End
   Begin VB.Label lblPath 
      Caption         =   "Apply Path:"
      Height          =   315
      Index           =   2
      Left            =   120
      TabIndex        =   6
      Top             =   1500
      Width           =   5415
   End
   Begin VB.Label lblPath 
      Caption         =   "Temporary Path:"
      Height          =   315
      Index           =   1
      Left            =   120
      TabIndex        =   3
      Top             =   780
      Width           =   5415
   End
   Begin VB.Label lblPath 
      Caption         =   "File Path:"
      Height          =   315
      Index           =   0
      Left            =   120
      TabIndex        =   0
      Top             =   60
      Width           =   5415
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_bAbort        As Boolean  ' // Abort flag
Private m_cWimImage     As Object   ' // CWIMImage obect that lives in other thread
Private m_lAsyncID      As Long
Private m_bIsInProgress As Boolean
Private m_lLogLen       As Long



Public Sub clock()

    Dim tParam1 As Long
    Dim tParam2 As Long
    Dim tParam3 As Long
    Dim tParam4 As Long
    Dim tParam5 As Long
    
    tParam1 = ExtractParam(tParam2, tParam3, tParam4, tParam5)
    'tParam1 = ExtractParam(tParam2, tParam3)
    
    If tParam1 = WIM_MSG_PROGRESS Then
    
        lblTestProgress.Caption = "Callback TID [0x" & Hex$(App.ThreadID) & "][0x" & Hex$(tParam5) & "] " & tParam1 & " | " & tParam2 & " | " & tParam3 & " | " & tParam4 & " | " & DateTime.Timer
    
    End If
    
    
End Sub








' // Called when image applying is done (no errors)
Public Sub Applied( _
           ByRef vRet As Variant)
           
    m_bIsInProgress = False
    PutLog "Applied!"
    cmdApply.Caption = "Apply"
    
End Sub

' // Abort applying
Private Sub Abort()

    m_bAbort = True
    
    If Not m_cWimImage Is Nothing Then
        Set m_cWimImage = Nothing
        ' // Wait until thread has terminated
        WaitForObjectThreadCompletion m_lAsyncID
    End If
    
    cmdApply.Caption = "Apply"
    m_bIsInProgress = False
        
End Sub

Private Sub cmdApply_Click()
    
    On Error GoTo err_handler
    
    If m_bIsInProgress Then
        Abort
    Else
        
        txtLog.Text = vbNullString: m_lLogLen = 0
        
        m_bAbort = False
        
        ' // Create object in new thread
        Set m_cWimImage = CreatePrivateObjectByNameInNewThread("CWIMImage", , m_lAsyncID)
        
        m_cWimImage.TempPath = txtTempPath.Text
        m_cWimImage.ApplyPath = txtApplyPath.Text
        m_cWimImage.AbortFlagAddress = VarPtr(m_bAbort)
        m_cWimImage.LoadFile txtPath.Text
        m_cWimImage.LoadImage 1
        
        txtImageinfo.Text = m_cWimImage.Information
        
        m_bIsInProgress = True
        
        cmdApply.Caption = "Abort"
        
        ' // Async call
        AsynchDispMethodCall m_lAsyncID, "Apply", VbMethod, Me, "Applied"
        
    End If
    
    Exit Sub
    
err_handler:
    
    MsgBox "Unexpected error!", vbCritical

End Sub

Private Sub cmdApplyPath_Click()
    Dim sFolder As String
    
    sFolder = BrowseFolder(Me.hwnd, "Apply folder path")
    If Len(sFolder) Then
        txtApplyPath.Text = sFolder
    End If
    
End Sub

Private Sub cmdPickTemp_Click()
    Dim sFolder As String
    
    sFolder = BrowseFolder(Me.hwnd, "Temporary folder path")
    If Len(sFolder) Then
        txtTempPath.Text = sFolder
    End If
    
End Sub

Private Sub cmdPickWIM_Click()
    Dim sFile   As String
    
    sFile = GetOpenFile(Me.hwnd, "Open WIM file", "WIM files" & vbNullChar & "*.wim" & vbNullChar)
    If Len(sFile) Then
        txtPath.Text = sFile
    End If
    
End Sub

Private Sub CheckPathes()
    cmdApply.Enabled = PathFileExists(StrPtr(txtPath.Text)) <> 0 And _
                       PathFileExists(StrPtr(txtTempPath.Text)) <> 0 And _
                       PathFileExists(StrPtr(txtApplyPath.Text)) <> 0
End Sub

Private Sub Form_Load()
    Dim cObj    As Object
    
    Me.Caption = Me.Caption & " [ThreadID: 0x" & Hex$(App.ThreadID) & "]"


    modMultiThreading.Initialize
    modMultiThreading.EnablePrivateMarshaling True
    InitLog
    
    
    
    
    Set cObj = Me
    
    ' // Make multiple marshaling stream to call Log method
    ' // We can unmarshal it multiple times in the different threads
    gpMarshalData = Marshal2(cObj)
    
    
    
End Sub



Private Sub Form_Unload(Cancel As Integer)


    
    Abort
    UninitLog
    
    
    FreeMarshalData gpMarshalData
    modMultiThreading.Uninitialize
    
End Sub

Private Sub tmrLog_Timer()
    Dim sLog    As String
    
    sLog = ExtractLog()
    If Len(sLog) = 0 Then Exit Sub
    
    txtLog.SelStart = m_lLogLen
    txtLog.SelText = sLog
    m_lLogLen = m_lLogLen + Len(sLog)
    
End Sub

Private Sub txtApplyPath_Change()
    CheckPathes
End Sub
Private Sub txtPath_Change()
    CheckPathes
End Sub
Private Sub txtTempPath_Change()
    CheckPathes
End Sub
